set linesize 32000
set pagesize 1000
set echo on
set termout on
set trimspool on

spool outlinehint.log

set define off

-- get version

select * from v$version;

-- create test table

drop table test;

create table test as select * from dba_tables;
create index testi on test(owner);
execute dbms_stats.gather_table_stats(NULL,'TEST');

-- Get plan for query with index hint including outline

explain plan into plan_table for 
select /*+index(test testi) */ * from test      
/

select * from table(dbms_xplan.display('PLAN_TABLE',NULL,'OUTLINE'));

-- Get plan for query with no hint

explain plan into plan_table for 
select * from test      
/

select * from table(dbms_xplan.display('PLAN_TABLE',NULL,'BASIC'));

-- Get plan forcing query using outline

explain plan into plan_table for 
select
  /*+
      BEGIN_OUTLINE_DATA
      INDEX(@"SEL$1" "TEST"@"SEL$1" ("TEST"."OWNER"))
      OUTLINE_LEAF(@"SEL$1")
      ALL_ROWS
      OPT_PARAM('_unnest_subquery' 'false')
      DB_VERSION('11.2.0.3')
      OPTIMIZER_FEATURES_ENABLE('11.2.0.3')
      IGNORE_OPTIM_EMBEDDED_HINTS
      END_OUTLINE_DATA
  */
* from test      
/

select * from table(dbms_xplan.display('PLAN_TABLE',NULL,'BASIC'));

spool off
